# coding: utf-8
from os.path import dirname

from pip.commands.install import InstallCommand
from pip.download import PipSession
from pip.req.req_file import parse_requirements
from setuptools import find_packages
from setuptools import setup


def _get_requirements(file_path):
    pip_session = PipSession()
    requirements = parse_requirements(file_path, session=pip_session)

    return tuple(str(requirement.req) for requirement in requirements)


def _get_index_urls():
    """Возвращает URL PyPI-сервера."""
    options, _ = InstallCommand().parse_args([])
    return [options.index_url] + options.extra_index_urls


def main():
    setup(
        name='m3-dev-utils',
        author='Andrey Chagochkin',
        author_email='andrey.chagochkin@bars-open.ru',
        description=(
            u'Инструментарий разработчика веб-приложений на платформе M3.'
        ),
        url=(
            'https://stash.bars-open.ru/users/andrey.chagochkin/repos/'
            'm3-dev-utils'
        ),
        package_dir={'': 'src'},
        packages=find_packages('src'),
        include_package_data=True,
        dependency_links=tuple(
            '/'.join((url, 'm3-builder'))
            for url in _get_index_urls()
        ),
        setup_requires=(
            'm3-builder>=1.1.1,<2',
        ),
        install_requires=_get_requirements('requirements/prod.txt'),
        set_build_info=dirname(__file__),
    )


if __name__ == '__main__':
    main()
